<template>
  <AmsSelect
    :select-id="filterId"
    :options="computedOptions"
    :selected-option="selected"
    :data-selected="selected"
    :variant="variant"
    :compact="compact"
    :open-indicator="openIndicator"
    :class="[
      $style['filterselect'],
      { 'filter-applied': showApplied && curVal !== 'all' },
    ]"
    @gotSelect="onFilterSelect"
  />
</template>

<script lang="ts">
import {
  defineComponent,
  onBeforeUnmount,
  computed,
} from "@nuxtjs/composition-api";
import useFiltering from "~/composables/filtering";

export default defineComponent({
  name: "AmsFilterSelect",

  components: {
    AmsSelect: () => import("~/components/_elements/Form/Select.vue"),
  },

  props: {
    filterId: {
      type: String,
      default: null,
    },
    noFilterString: {
      type: String,
      default: "all",
    },
    variant: {
      type: String,
      default: "outlined",
    },
    compact: {
      type: Boolean,
      default: false,
    },
    showApplied: {
      type: Boolean,
      default: true,
    },
    options: {
      type: Array,
      default: null,
    },
    currentValue: {
      type: String,
      default: "all",
    },
    openIndicator: {
      type: String,
      default: "SvgCaretDown",
    },
  },

  setup (props, ctx) {
    const { filter, uniqueValuesPerFilterableColumn } = useFiltering();

    const curVal = computed(() => props.currentValue);

    const computedOptions = computed((): any[] => {
      let options = props.options;

      if (props.options) {
        options = props.options;
      } else {
        options = [
          props.noFilterString,
          ...uniqueValuesPerFilterableColumn[props.filterId],
        ];

        options.map((o) => {
          return {
            value: o === props.noFilterString ? "all" : o,
            label: o,
          };
        });
      }

      return options;
    });

    const selected = computed(() => {
      return computedOptions.value.reduce((a, c, i) => {
        return c.value === curVal.value ? i : a;
      }, 0);
    });

    function onFilterSelect ({ value, id }) {
      filter(value, id);
      ctx.emit("filterApplied", { value, id });
    }

    // Reset the filter state when routing.
    onBeforeUnmount(() => filter());

    return {
      curVal,
      computedOptions,
      selected,
      onFilterSelect,
    };
  },
});
</script>

<style lang="postcss" module>
.filterselect {
  @apply relative flex justify-center items-center mt-1 mx-2;

  &:disabled {
    &::before {
      @apply hidden;
    }
  }
}
</style>

<style lang="postcss" scoped>
.filter-applied.outlined {
  @apply bg-gray-600 text-gray-150;
}
</style>
